//+------------------------------------------------------------------+
//|                                                   SampleMQL5.mq5 |
//|                                             Copyright KlimMalgin |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "KlimMalgin"
#property link      ""
#property version   "1.00"


int MA1 = 0,            //       MA
    MA2 = 0,            //       MA
    SAR = 0;            //      SAR
    
MqlParam params[];      //     

//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
   
/*************************************************/
/*        ( ) */
/*************************************************

   //   params   
   //  
   ArrayResize(params,4);

//*         *
//***************************
   //    MA
   params[0].type         =TYPE_INT;
   params[0].integer_value=5;
   // 
   params[1].type         =TYPE_INT;
   params[1].integer_value=0;
   //  :  
   params[2].type         =TYPE_INT;
   params[2].integer_value=MODE_SMA;
   //    :  
   params[3].type         =TYPE_INT;
   params[3].integer_value=PRICE_CLOSE;
   
   MA1 = IndicatorCreate(Symbol(), 0, IND_MA, 4, params);
   
   //    MA
   params[0].type         =TYPE_INT;
   params[0].integer_value=21;
   // 
   params[1].type         =TYPE_INT;
   params[1].integer_value=0;
   //  :  
   params[2].type         =TYPE_INT;
   params[2].integer_value=MODE_SMA;
   //    :  
   params[3].type         =TYPE_INT;
   params[3].integer_value=PRICE_CLOSE;
   
   MA2 = IndicatorCreate(Symbol(), 0, IND_MA, 4, params);
   
   
   //        SAR
   ArrayResize(params,2);
   // 
   params[0].type         =TYPE_DOUBLE;
   params[0].double_value = 0.02;
   // 
   params[1].type         =TYPE_DOUBLE;
   params[1].double_value = 0.2;
   
   SAR = IndicatorCreate(Symbol(), 0, IND_SAR, 2, params);
   
   
/*************************************************/
/*                  */
/*************************************************/
   ResetLastError();
   MA1 = iCustom(NULL,0,"Examples\\Custom Moving Average",
                          5,          // 
                          0,          // 
                          MODE_SMA,   //  
                          PRICE_CLOSE //    
                 );
   Print("MA1 =",MA1,"  error =",GetLastError());
   ResetLastError();
   MA2 = iCustom(NULL,0,"Examples\\Custom Moving Average",
                          21,         // 
                          0,          // 
                          MODE_SMA,   //  
                          PRICE_CLOSE //    
                 );
   Print("MA2 =",MA2,"  error =",GetLastError());
   ResetLastError();

   SAR = iCustom(NULL,0,"Examples\\ParabolicSAR",
                          0.02,        // 
                          0.2          // 
                 );
   Print("SAR =",SAR,"  error =",GetLastError());
   

//---
   return(0);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---

//      
double _ma1[],
       _ma2[],
       _sar[];

//      ,   ,
// ..       ,  -   ..
   ArraySetAsSeries(_ma1, true);
   ArraySetAsSeries(_ma2, true);
   ArraySetAsSeries(_sar, true);

//   ,    
//       
   if (CopyBuffer(MA1,0,0,20,_ma1) < 0){Print("CopyBufferMA1 error =",GetLastError());}
   if (CopyBuffer(MA2,0,0,20,_ma2) < 0){Print("CopyBufferMA2 error =",GetLastError());}
   if (CopyBuffer(SAR,0,0,20,_sar) < 0){Print("CopyBufferSAR error =",GetLastError());}

//---
  }
//+------------------------------------------------------------------+
